58b24e384145fec5525add5036a618539c6debff
1#!/bin/sh
2
3USAGE='[help|start|bad|good|skip|next|reset|visualize|replay|log|run]'
4LONG_USAGE='git bisect help
5 print this long help message.
6git bisect start [<bad> [<good>...]] [--] [<pathspec>...]
7 reset bisect state and start bisection.
8git bisect bad [<rev>]
9 mark <rev> a known-bad revision.
10git bisect good [<rev>...]
11 mark <rev>... known-good revisions.
12git bisect skip [(<rev>|<range>)...]
13 mark <rev>... untestable revisions.
14git bisect next
15 find next bisection to test and check it out.
16git bisect reset [<commit>]
17 finish bisection search and go back to commit.
18git bisect visualize
19 show bisect status in gitk.
20git bisect replay <logfile>
21 replay bisection log.
22git bisect log
23 show bisect log.
24git bisect run <cmd>...
25 use <cmd>... to automatically bisect.
26
27Please use "git help bisect" to get the full man page.'
28
29OPTIONS_SPEC=
30. git-sh-setup
31. git-sh-i18n
32require_work_tree
33
34_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
35_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
36
37bisect_autostart() {
38 test -s "$GIT_DIR/BISECT_START" || {
39 (
40 gettext "You need to start by \"git bisect start\"" &&
41 echo
42 ) >&2
43 if test -t 0
44 then
45 echo >&2 -n 'Do you want me to do it for you [Y/n]? '
46 read yesno
47 case "$yesno" in
48 [Nn]*)
49 exit ;;
50 esac
51 bisect_start
52 else
53 exit 1
54 fi
55 }
56}
57
58bisect_start() {
59 #
60 # Verify HEAD.
61 #
62 head=$(GIT_DIR="$GIT_DIR" git symbolic-ref -q HEAD) ||
63 head=$(GIT_DIR="$GIT_DIR" git rev-parse --verify HEAD) ||
64 die "$(gettext "Bad HEAD - I need a HEAD")"
65
66 #
67 # Check if we are bisecting.
68 #
69 start_head=''
70 if test -s "$GIT_DIR/BISECT_START"
71 then
72 # Reset to the rev from where we started.
73 start_head=$(cat "$GIT_DIR/BISECT_START")
74 git checkout "$start_head" -- || exit
75 else
76 # Get rev from where we start.
77 case "$head" in
78 refs/heads/*|$_x40)
79 # This error message should only be triggered by
80 # cogito usage, and cogito users should understand
81 # it relates to cg-seek.
82 [ -s "$GIT_DIR/head-name" ] &&
83 die "$(gettext "won't bisect on seeked tree")"
84 start_head="${head#refs/heads/}"
85 ;;
86 *)
87 die "$(gettext "Bad HEAD - strange symbolic ref")"
88 ;;
89 esac
90 fi
91
92 #
93 # Get rid of any old bisect state.
94 #
95 bisect_clean_state || exit
96
97 #
98 # Check for one bad and then some good revisions.
99 #
100 has_double_dash=0
101 for arg; do
102 case "$arg" in --) has_double_dash=1; break ;; esac
103 done
104 orig_args=$(git rev-parse --sq-quote "$@")
105 bad_seen=0
106 eval=''
107 while [ $# -gt 0 ]; do
108 arg="$1"
109 case "$arg" in
110 --)
111 shift
112 break
113 ;;
114 *)
115 rev=$(git rev-parse -q --verify "$arg^{commit}") || {
116 test $has_double_dash -eq 1 &&
117 die "$(eval_gettext "'\$arg' does not appear to be a valid revision")"
118 break
119 }
120 case $bad_seen in
121 0) state='bad' ; bad_seen=1 ;;
122 *) state='good' ;;
123 esac
124 eval="$eval bisect_write '$state' '$rev' 'nolog'; "
125 shift
126 ;;
127 esac
128 done
129
130 #
131 # Change state.
132 # In case of mistaken revs or checkout error, or signals received,
133 # "bisect_auto_next" below may exit or misbehave.
134 # We have to trap this to be able to clean up using
135 # "bisect_clean_state".
136 #
137 trap 'bisect_clean_state' 0
138 trap 'exit 255' 1 2 3 15
139
140 #
141 # Write new start state.
142 #
143 echo "$start_head" >"$GIT_DIR/BISECT_START" &&
144 git rev-parse --sq-quote "$@" >"$GIT_DIR/BISECT_NAMES" &&
145 eval "$eval" &&
146 echo "git bisect start$orig_args" >>"$GIT_DIR/BISECT_LOG" || exit
147 #
148 # Check if we can proceed to the next bisect state.
149 #
150 bisect_auto_next
151
152 trap '-' 0
153}
154
155bisect_write() {
156 state="$1"
157 rev="$2"
158 nolog="$3"
159 case "$state" in
160 bad) tag="$state" ;;
161 good|skip) tag="$state"-"$rev" ;;
162 *) die "$(eval_gettext "Bad bisect_write argument: \$state")" ;;
163 esac
164 git update-ref "refs/bisect/$tag" "$rev" || exit
165 echo "# $state: $(git show-branch $rev)" >>"$GIT_DIR/BISECT_LOG"
166 test -n "$nolog" || echo "git bisect $state $rev" >>"$GIT_DIR/BISECT_LOG"
167}
168
169is_expected_rev() {
170 test -f "$GIT_DIR/BISECT_EXPECTED_REV" &&
171 test "$1" = $(cat "$GIT_DIR/BISECT_EXPECTED_REV")
172}
173
174check_expected_revs() {
175 for _rev in "$@"; do
176 if ! is_expected_rev "$_rev"; then
177 rm -f "$GIT_DIR/BISECT_ANCESTORS_OK"
178 rm -f "$GIT_DIR/BISECT_EXPECTED_REV"
179 return
180 fi
181 done
182}
183
184bisect_skip() {
185 all=''
186 for arg in "$@"
187 do
188 case "$arg" in
189 *..*)
190 revs=$(git rev-list "$arg") || die "$(eval_gettext "Bad rev input: \$arg")" ;;
191 *)
192 revs=$(git rev-parse --sq-quote "$arg") ;;
193 esac
194 all="$all $revs"
195 done
196 eval bisect_state 'skip' $all
197}
198
199bisect_state() {
200 bisect_autostart
201 state=$1
202 case "$#,$state" in
203 0,*)
204 die "$(gettext "Please call 'bisect_state' with at least one argument.")" ;;
205 1,bad|1,good|1,skip)
206 rev=$(git rev-parse --verify HEAD) ||
207 die "$(gettext "Bad rev input: HEAD")"
208 bisect_write "$state" "$rev"
209 check_expected_revs "$rev" ;;
210 2,bad|*,good|*,skip)
211 shift
212 eval=''
213 for rev in "$@"
214 do
215 sha=$(git rev-parse --verify "$rev^{commit}") ||
216 die "$(eval_gettext "Bad rev input: \$rev")"
217 eval="$eval bisect_write '$state' '$sha'; "
218 done
219 eval "$eval"
220 check_expected_revs "$@" ;;
221 *,bad)
222 die "$(gettext "'git bisect bad' can take only one argument.")" ;;
223 *)
224 usage ;;
225 esac
226 bisect_auto_next
227}
228
229bisect_next_check() {
230 missing_good= missing_bad=
231 git show-ref -q --verify refs/bisect/bad || missing_bad=t
232 test -n "$(git for-each-ref "refs/bisect/good-*")" || missing_good=t
233
234 case "$missing_good,$missing_bad,$1" in
235 ,,*)
236 : have both good and bad - ok
237 ;;
238 *,)
239 # do not have both but not asked to fail - just report.
240 false
241 ;;
242 t,,good)
243 # have bad but not good. we could bisect although
244 # this is less optimum.
245 (
246 gettext "Warning: bisecting only with a bad commit." &&
247 echo
248 ) >&2
249 if test -t 0
250 then
251 printf >&2 'Are you sure [Y/n]? '
252 read yesno
253 case "$yesno" in [Nn]*) exit 1 ;; esac
254 fi
255 : bisect without good...
256 ;;
257 *)
258 THEN=''
259 test -s "$GIT_DIR/BISECT_START" || {
260 echo >&2 'You need to start by "git bisect start".'
261 THEN='then '
262 }
263 echo >&2 'You '$THEN'need to give me at least one good' \
264 'and one bad revisions.'
265 echo >&2 '(You can use "git bisect bad" and' \
266 '"git bisect good" for that.)'
267 exit 1 ;;
268 esac
269}
270
271bisect_auto_next() {
272 bisect_next_check && bisect_next || :
273}
274
275bisect_next() {
276 case "$#" in 0) ;; *) usage ;; esac
277 bisect_autostart
278 bisect_next_check good
279
280 # Perform all bisection computation, display and checkout
281 git bisect--helper --next-all
282 res=$?
283
284 # Check if we should exit because bisection is finished
285 test $res -eq 10 && exit 0
286
287 # Check for an error in the bisection process
288 test $res -ne 0 && exit $res
289
290 return 0
291}
292
293bisect_visualize() {
294 bisect_next_check fail
295
296 if test $# = 0
297 then
298 if test -n "${DISPLAY+set}${SESSIONNAME+set}${MSYSTEM+set}${SECURITYSESSIONID+set}" &&
299 type gitk >/dev/null 2>&1; then
300 set gitk
301 else
302 set git log
303 fi
304 else
305 case "$1" in
306 git*|tig) ;;
307 -*) set git log "$@" ;;
308 *) set git "$@" ;;
309 esac
310 fi
311
312 eval '"$@"' --bisect -- $(cat "$GIT_DIR/BISECT_NAMES")
313}
314
315bisect_reset() {
316 test -s "$GIT_DIR/BISECT_START" || {
317 gettext "We are not bisecting."; echo
318 return
319 }
320 case "$#" in
321 0) branch=$(cat "$GIT_DIR/BISECT_START") ;;
322 1) git rev-parse --quiet --verify "$1^{commit}" > /dev/null || {
323 invalid="$1"
324 die "$(eval_gettext "'\$invalid' is not a valid commit")"
325 }
326 branch="$1" ;;
327 *)
328 usage ;;
329 esac
330 if git checkout "$branch" -- ; then
331 bisect_clean_state
332 else
333 die "$(eval_gettext "Could not check out original HEAD '\$branch'.
334Try 'git bisect reset <commit>'.")"
335 fi
336}
337
338bisect_clean_state() {
339 # There may be some refs packed during bisection.
340 git for-each-ref --format='%(refname) %(objectname)' refs/bisect/\* |
341 while read ref hash
342 do
343 git update-ref -d $ref $hash || exit
344 done
345 rm -f "$GIT_DIR/BISECT_EXPECTED_REV" &&
346 rm -f "$GIT_DIR/BISECT_ANCESTORS_OK" &&
347 rm -f "$GIT_DIR/BISECT_LOG" &&
348 rm -f "$GIT_DIR/BISECT_NAMES" &&
349 rm -f "$GIT_DIR/BISECT_RUN" &&
350 # Cleanup head-name if it got left by an old version of git-bisect
351 rm -f "$GIT_DIR/head-name" &&
352
353 rm -f "$GIT_DIR/BISECT_START"
354}
355
356bisect_replay () {
357 file="$1"
358 test "$#" -eq 1 || die "$(gettext "No logfile given")"
359 test -r "$file" || die "$(eval_gettext "cannot read \$file for replaying")"
360 bisect_reset
361 while read git bisect command rev
362 do
363 test "$git $bisect" = "git bisect" -o "$git" = "git-bisect" || continue
364 if test "$git" = "git-bisect"; then
365 rev="$command"
366 command="$bisect"
367 fi
368 case "$command" in
369 start)
370 cmd="bisect_start $rev"
371 eval "$cmd" ;;
372 good|bad|skip)
373 bisect_write "$command" "$rev" ;;
374 *)
375 die "$(gettext "?? what are you talking about?")" ;;
376 esac
377 done <"$file"
378 bisect_auto_next
379}
380
381bisect_run () {
382 bisect_next_check fail
383
384 while true
385 do
386 command="$@"
387 eval_gettext "running \$command"; echo
388 "$@"
389 res=$?
390
391 # Check for really bad run error.
392 if [ $res -lt 0 -o $res -ge 128 ]; then
393 (
394 eval_gettext "bisect run failed:
395exit code \$res from '\$command' is < 0 or >= 128" &&
396 echo
397 ) >&2
398 exit $res
399 fi
400
401 # Find current state depending on run success or failure.
402 # A special exit code of 125 means cannot test.
403 if [ $res -eq 125 ]; then
404 state='skip'
405 elif [ $res -gt 0 ]; then
406 state='bad'
407 else
408 state='good'
409 fi
410
411 # We have to use a subshell because "bisect_state" can exit.
412 ( bisect_state $state > "$GIT_DIR/BISECT_RUN" )
413 res=$?
414
415 cat "$GIT_DIR/BISECT_RUN"
416
417 if sane_grep "first bad commit could be any of" "$GIT_DIR/BISECT_RUN" \
418 > /dev/null; then
419 (
420 gettext "bisect run cannot continue any more" &&
421 echo
422 ) >&2
423 exit $res
424 fi
425
426 if [ $res -ne 0 ]; then
427 (
428 eval_gettext "bisect run failed:
429'bisect_state \$state' exited with error code \$res" &&
430 echo
431 ) >&2
432 exit $res
433 fi
434
435 if sane_grep "is the first bad commit" "$GIT_DIR/BISECT_RUN" > /dev/null; then
436 gettext "bisect run success"; echo
437 exit 0;
438 fi
439
440 done
441}
442
443bisect_log () {
444 test -s "$GIT_DIR/BISECT_LOG" || die "$(gettext "We are not bisecting.")"
445 cat "$GIT_DIR/BISECT_LOG"
446}
447
448case "$#" in
4490)
450 usage ;;
451*)
452 cmd="$1"
453 shift
454 case "$cmd" in
455 help)
456 git bisect -h ;;
457 start)
458 bisect_start "$@" ;;
459 bad|good)
460 bisect_state "$cmd" "$@" ;;
461 skip)
462 bisect_skip "$@" ;;
463 next)
464 # Not sure we want "next" at the UI level anymore.
465 bisect_next "$@" ;;
466 visualize|view)
467 bisect_visualize "$@" ;;
468 reset)
469 bisect_reset "$@" ;;
470 replay)
471 bisect_replay "$@" ;;
472 log)
473 bisect_log ;;
474 run)
475 bisect_run "$@" ;;
476 *)
477 usage ;;
478 esac
479esac